searchNodes=[{"doc":"Tangent provides functions and macros for bridging global Agent processes with ExUnit tests configured to be async: true . Usage Tangent can be used as a drop-in replacement for Agent : defmodule MyTangent do use Tangent def start_link ( _ ) , do : Tangent . start_link ( fn -&gt; 0 end , name : __MODULE__ ) def current ( ) , do : Tangent . get ( __MODULE__ , &amp; &amp;1 ) def increment ( ) , do : Tangent . get_and_update ( __MODULE__ , fn current -&gt; { current + 1 , current + 1 } end ) def decrement ( ) , do : Tangent . get_and_update ( __MODULE__ , fn current -&gt; { current - 1 , current - 1 } end ) end When Mix.env/0 is not equal to :test , this will compile to use Agent directly. In :test mode, this will instead compile to use an interceptor process. By default this process will behave like an Agent , with a single global dataset that will be accessed when callers access Tangent . Test processes can register themselves as owners of dataset overloads via the Tangent.Test.overload/1 macro. If a process that traces its ancestry to the owner attempts to access the data, it will only get/update the overloaded dataset specific to the owner. defmodule MyTangentTest do use ExUnit.Case , async : true use Tangent.Test setup do Tangent.Test . overload ( MyTangent ) end describe &quot;increment&quot; do test &quot;increments the saved value&quot; do assert MyTangent . current ( ) == 0 assert MyTangent . increment ( ) == 1 assert MyTangent . increment ( ) == 2 assert MyTangent . current ( ) == 2 spawn fn -&gt; assert MyTangent . current ( ) == 0 assert MyTangent . increment ( ) == 1 assert MyTangent . current ( ) == 1 end Task . async fn -&gt; assert MyTangent . current ( ) == 2 end |&gt; Task . await ( ) assert MyTangent . current ( ) == 2 end end end Note that the above works because Task.async/1 spawns a process with an ancestry list, while spawn/1 spawns a process with no ancestry.","ref":"Tangent.html","title":"Tangent","type":"module"},{"doc":"","ref":"Tangent.html#cast/2","title":"Tangent.cast/2","type":"macro"},{"doc":"","ref":"Tangent.html#cast/4","title":"Tangent.cast/4","type":"macro"},{"doc":"","ref":"Tangent.html#get/3","title":"Tangent.get/3","type":"macro"},{"doc":"","ref":"Tangent.html#get/5","title":"Tangent.get/5","type":"macro"},{"doc":"","ref":"Tangent.html#get_and_update/3","title":"Tangent.get_and_update/3","type":"macro"},{"doc":"","ref":"Tangent.html#get_and_update/5","title":"Tangent.get_and_update/5","type":"macro"},{"doc":"","ref":"Tangent.html#start_link/2","title":"Tangent.start_link/2","type":"macro"},{"doc":"","ref":"Tangent.html#start_link/4","title":"Tangent.start_link/4","type":"macro"},{"doc":"","ref":"Tangent.html#stop/3","title":"Tangent.stop/3","type":"macro"},{"doc":"","ref":"Tangent.html#update/3","title":"Tangent.update/3","type":"macro"},{"doc":"","ref":"Tangent.html#update/5","title":"Tangent.update/5","type":"macro"},{"doc":"","ref":"Tangent.html#t:agent/0","title":"Tangent.agent/0","type":"type"},{"doc":"","ref":"Tangent.html#t:on_start/0","title":"Tangent.on_start/0","type":"type"},{"doc":"","ref":"Tangent.html#t:state/0","title":"Tangent.state/0","type":"type"},{"doc":"Test helpers to register agent state overloads. Usage defmodule MyTest do use ExUnit.Case , async : true use Tangent.Test setup do Tangent.Test . overload ( MyAgent ) end # // ... end","ref":"Tangent.Test.html","title":"Tangent.Test","type":"module"},{"doc":"Registers the current process as the owner of an overload. Processes that can trace their ancestry to the owner will access a segmented dataset when interacting with the named agent, rather than accessing global state. If passing an overload to a process that has not been started by the current process, Tangent.Test.Agent.register/2 should be used directly.","ref":"Tangent.Test.html#overload/1","title":"Tangent.Test.overload/1","type":"macro"},{"doc":"An agent which will be started in the test environment in place of Agent .","ref":"Tangent.Test.Agent.html","title":"Tangent.Test.Agent","type":"module"},{"doc":"","ref":"Tangent.Test.Agent.html#ensure_started!/1","title":"Tangent.Test.Agent.ensure_started!/1","type":"function"},{"doc":"Registers the owner process as the parent of any agent overloads. After registering an overload, any process that is a child of the caller will access a segmented dataset when accessing the agent.","ref":"Tangent.Test.Agent.html#register/2","title":"Tangent.Test.Agent.register/2","type":"function"},{"doc":"Overview Let your Agent calls go on a tangent. Tangent provides functions and macros for bridging global Agent processes with ExUnit tests configured to be async: true .","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"def deps do [ { :tangent , &quot;~&gt; 0.1.0&quot; } ] end","ref":"overview.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"When using Agent processes to store state, it is common practices to start the processes from an application's supervisor. Unit tests of the agent may use ExUnit.Callbacks.start_supervised/2 to test interactions in isolation, but when testing things like Phoenix controllers of Phoenix.LiveView, cross-process interactions may mutate the state of the global agent, causing test pollution across asynchronous processes.","ref":"overview.html#problem-statement","title":"Overview - Problem Statement","type":"extras"},{"doc":"Tangent is intended to be a drop-in replacement for the Agent module that ships with Elixir. defmodule MyAgent do use Agent def start_link ( _ ) , do : Agent . start_link ( fn -&gt; 0 end , name : __MODULE__ ) def current ( ) , do : Agent . get ( __MODULE__ , &amp; &amp;1 ) def increment ( ) , do : Agent . get_and_update ( __MODULE__ , fn current -&gt; { current + 1 , current + 1 } end ) def decrement ( ) , do : Agent . get_and_update ( __MODULE__ , fn current -&gt; { current - 1 , current - 1 } end ) end ↓ defmodule MyTangent do use Tangent def start_link ( _ ) , do : Tangent . start_link ( fn -&gt; 0 end , name : __MODULE__ ) def current ( ) , do : Tangent . get ( __MODULE__ , &amp; &amp;1 ) def increment ( ) , do : Tangent . get_and_update ( __MODULE__ , fn current -&gt; { current + 1 , current + 1 } end ) def decrement ( ) , do : Tangent . get_and_update ( __MODULE__ , fn current -&gt; { current - 1 , current - 1 } end ) end When code is compiled in Mix.env() == :test , the underlying agent is swapped out for an interceptor. This interceptor keeps data in a global dataset, so by default it will act like a global Agent . Test processes can use Tangent.Test to register themselves as the parent of overloaded datasets. After overloading an agent, any child process of the test will access the overloaded, rather than the global, dataset. defmodule MyTangentTest do use ExUnit.Case , async : true use Tangent.Test setup do Tangent.Test . overload ( MyTangent ) end describe &quot;increment&quot; do test &quot;increments the saved value&quot; do assert MyTangent . current ( ) == 0 assert MyTangent . increment ( ) == 1 assert MyTangent . current ( ) == 1 end end end defmodule MyOtherTangentTest do use ExUnit.Case , async : true use Tangent.Test setup do Tangent.Test . overload ( MyTangent ) end describe &quot;decrement&quot; do test &quot;decrements the saved value&quot; do assert MyTangent . current ( ) == 0 assert MyTangent . decrement ( ) == - 1 assert MyTangent . current ( ) == - 1 end end end","ref":"overview.html#usage","title":"Overview - Usage","type":"extras"}]